﻿@model eCommerce.UI.ViewModels.ShoppingCartViewModel
@using eCommerce.Services.Model.Enums
@using eCommerce.Services.Utils
@{
    this.Layout = "~/Views/Shared/_LayoutPagoDecidir.cshtml";
    ViewBag.Title = "Relizá tu pago";
}

<div class="checkout checkout--summary">
    <div class="checkout__header">
        <div class="content__container">

            <h2 class="checkout__header-title">Pagar - Pedido #@Model.OrderId</h2>
            <input type="hidden" value="@Model.Guid" class="CustomerGuid" />


            <div class="checkout__header-action -tablet">
                <span class="checkout__header-action-text js-toggle-summary">Ver resumen</span>
            </div>
        </div>
    </div>

    @if (Model.BankList != null)
    {
        using (Html.BeginForm("PagoDecidir", "Payment", FormMethod.Post, new { @id = "DecidirForm" }))
        {
            <input type="hidden" name="OrderId" id="OrderId" value="@Model.OrderId" />

            <div class="checkout__body" style="font-family:AVENIRLTSTD-MEDIUM">
                <div class="content__container checkout__container">

                    <div class="checkout__steps-container">

                        @Html.Partial("Checkout/CreditCard/CreditCardData", Model)

                    </div>

                    <div class="checkout__summary js-summary">

                        @Html.Partial("Checkout/Summary/Summary", Model)

                    </div>

                    <div class="checkout__finish">
                        <span class="checkout__total">Total: <span class="js-total-mobile">@Model.Total.ToString("c2")</span></span>

                        <button type="submit" class="button checkout__button js-end-order">Pagar</button>
                    </div>
                </div>
            </div>

        }
    }
    else
    {
        <div style="text-align:center;margin-top:3rem;">
            <div class="lead">
                No es posible realizar el pago de la venta ingresada.
            </div>
        </div>
    }


</div>


@section Scripts{


    <script src="https://live.decidir.com/static/v2.5/decidir.js"></script>
    <script>

        $(document).ready(function ()
        {
            if ($(".checkout__body").length == 0)
                return;

            $(".checkout__step").toggleClass("hidden", false);

            $('.js-security-code').removeAttr('autocomplete');
            $('.js-holder-name').removeAttr('autocomplete');

            var discountElem = $('.js-discount').find('.pricing-item__total').val(1);

            var discountText = discountElem.text().split('$')[1];

            if (discountText.indexOf('.') == -1) {
                var discount = discountText;
            }
            else {
                var discount = discountText.replace('.', ',').replace(',', '');
            }
            $('#Discount').val(discount);

            $('.js-credit-card-number').mask('0000-0000-0000-0000');
            $('.js-security-code').mask('0000');
            $('.js-expiration-month').mask('00');
            $('.js-expiration-year').mask('00');

            var currentSubtotal =  $('.js-subtotal').find('.pricing-item__total').text();
            var currentDiscount =  $('.js-discount').find('.pricing-item__total').text();

            var subtotalValue = currentSubtotal.replace("$", "").replace(".", "").replace(",", ".")
            var discountValue = currentDiscount.replace("$", "").replace(".", "").replace(",", ".")

            $('.js-subtotal').find('.pricing-item__total').text(formatCurrency(subtotalValue));
            $('.js-discount').find('.pricing-item__total').text(formatCurrency(discountValue));

            SumShippingCostAndDiscount();

            $(".bank-select").change();
        });

        //funcion de invocacion con sdk
        function ValidateDecidir()
        {
            var form = document.getElementById('formDecidir');
            if (validFormDecidir(form))
            {
                //var publicApiKey = "e9cdb99fff374b5f91da4480c8dca741";
                //var urlSandbox = "https://developers.decidir.com/api/v2";
                //var decidir = new Decidir(urlSandbox);

                //Verified - Fibra Humana
                var publicApiKey = "18809269472249b8981f617f744f2e0a";
                var urlProd = "https://live.decidir.com/api/v2";
                var decidir = new Decidir(urlProd);

                decidir.setPublishableKey(publicApiKey);
                decidir.setTimeout(5000);//timeout de 5 segundos
                decidir.createToken(form, function (status, response)
                {
                    if (status != 200 && status != 201)
                    {
                        console.log(response);
                        //Manejo de error: Ver Respuesta de Error

                        toastr.warning("Hubo un error al validar los datos de su tarjeta");
                        $('.js-end-order').attr('disabled', false);
                        //...codigo...
                    }
                    else
                    {
                        debugger;
                        var token = response.id;
                        var bin = response.bin;

                        var optionSelected = $('.bankinterest-select option:selected');
                        var installments = optionSelected.data('installments');
                        $('.checkout__body').append('<input type="hidden" name="decidir-token" value=' + token + ' />');
                        $('.checkout__body').append('<input type="hidden" name="decidir-bin" value=' + bin + ' />');
                        $('.checkout__body').append('<input type="hidden" name="decidir-installments" value=' + installments + ' />');

                        $("#DecidirForm").submit();
                    }
                });
                //formulario y callback
            }
            else {
                toastr.warning("Ingrese todos los campos correctamente.");
                $('.js-end-order').attr('disabled', false);
            }
        }

        $('.bankinterest-select').change(function() {

            if($(this).val() != null)
            {
                var optionSelected = $('.bankinterest-select option:selected');

                var surcharge = optionSelected.data('surcharge');

                var surchargeElem = $('.js-surcharge');
                surchargeElemValue = surchargeElem.find('.pricing-item__total');
                var toggle = false;
                if (parseFloat(surcharge) > 0)
                {
                    toggle = true;

                    var subtotalText = $('.js-subtotal').find('.pricing-item__total').text();
                    var discountText = $('.js-discount').find('.pricing-item__total').text();
                    var shippingCostText = $('.js-shipping-cost').find('.pricing-item__total').text();

                    var subtotalValue = parseFloat(subtotalText.replace("$","").replace(",", ""));

                    var discountValue = 0;
                    if(discountText)
                        discountValue = parseFloat(discountText.replace("$","").replace(",", ""));

                    var shippingCostValue = 0;
                    if(shippingCostText)
                        shippingCostValue = parseFloat(shippingCostText.replace("$","").replace(",", ""));

                    var currentTotal = subtotalValue - discountValue + shippingCostValue;
                    var surchargeTotal = currentTotal * surcharge / 100;

                    $('#Surcharge').val(surchargeTotal)
                    surchargeElemValue.text(formatCurrency(surchargeTotal));
                }
                else
                {
                    $('#Surcharge').val(0)
                    surchargeElemValue.text(formatCurrency(0));
                }

                SumShippingCostAndDiscount();

                surchargeElem.toggleClass('hide', !toggle);
            }
        });

        function ValueToStringWithoutDot(amount){
            return parseFloat(amount.toString().replace('.',''));
        }

        $('.bank-select').change(function ()
        {
            debugger;
            var currentBankId = $('.bank-select option:selected').val();
            var customerUserType = @(Model.Customer != null? Model.Customer.UserType : -1);

            if (currentBankId && customerUserType != -1)
            {
                $.ajax({
                    type: "GET",
                    cache: false,
                    url: "/ShoppingCart/GetInterestsForSelectedBank",
                    data: { BankId: currentBankId, UserType: customerUserType},
                    success: function (data) 
                    {
                        var $interests = data.Interests;
                        var total = parseFloat($('.pricing-item__total').html().replace('$', '').replace(',', ''));

                        if ($interests != null) {
                            if ($interests.length > 0) {
                                var selectToAppend = $('.bankinterest-select');
                                $('.bankinterest-list').removeClass('hide');

                                selectToAppend.empty();

                                $($interests).each(function(i, item) 
                                {
                                    if(item.MinAmount <= total || item.MinAmount == null) {
                                        selectToAppend.append('<option value="' +  item.Id + '" data-installments="' + item.Installments + '" data-surcharge="' + item.Surcharge + '">' + item.Name + '</option>');
                                    }
                                });

                                $('.bankinterest-select').change();
                            }
                            else {
                                toastr.warning("No hay promociones disponibles para el banco seleccionado.");
                            }
                        }
                        else {
                            toastr.warning("Se produjo un error al obtener las promociones del banco seleccionado.");
                        }
                    }
                });
            }

        });

        function validFormDecidir(form)
        {
            return true;
            var isValid = true;
            $(form).find('.step-form__group-input').each(function ()
            {
                if ($(this).data('decidir') == "card_number" && $(this).val().length != 19) {
                    isValid = false;
                } else if ($(this).data('decidir') == "security_code" && $(this).val().length != 3) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_expiration_month" && $(this).val().length != 2) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_expiration_year" && $(this).val().length != 2) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_holder_name" && $(this).val().length == 0) {
                    isValid = false;
                }
                else if ($(this).data('decidir') == "card_holder_doc_number" && $(this).val().length == 0) {
                    isValid = false;
                }
            });
            return isValid;
        }

        $('.js-toggle-cart').click(function ()
        {
            var $cart = $(this).closest('.checkout__summary').find('.js-toggable');
            var $toggle = $(this).find('.icon-toggle');

            $cart.toggleClass('cart-summary__body--shown');
            $toggle.toggleClass('icon--toggle');
        });

        $('.js-toggle-summary').click(function () {
            $('.js-summary').toggleClass('checkout__summary--open');
        });


        function SumShippingCostAndDiscount()
        {
            var shippingCost = 0;
            var surcharge = 0;

            var totalElem = $('.js-total').find('.pricing-item__total');
            var discountElem = $('.js-discount').find('.pricing-item__total');

            var totalText = totalElem.text().split('$')[1];
            var discountText = discountElem.text().split('$')[1];

           if (discountText.indexOf(',') == -1) {
                var discount = discountText;
            }
            else {
                var discount = discountText.replace(',', '');
            }

            shippingCost = $('.js-shipping-cost').find('.pricing-item__total').text().split('$')[1];
            surcharge = $('.js-surcharge').find('.pricing-item__total').text().split('$')[1];
            var surchargeValue = surcharge.replace(',', '');

            var subtotalText = $('.js-subtotal').find('.pricing-item__total').text().split('$')[1];

            var subtotal = subtotalText.replace(',', '');

            var newTotal = parseFloat(subtotal) - parseFloat(discount) + parseFloat(shippingCost) + parseFloat(surchargeValue);

            totalElem.val(newTotal);
            var formattedTotal = formatCurrency(newTotal);
            totalElem.text(formattedTotal);
            $('.js-total-mobile').text(formattedTotal);
        }

        function formatCurrency(total) {
            return '$' + parseFloat(total, 10).toFixed(2).replace(/(\d)(?=(\d{3})+\.)/g, "$1,").toString();
        }

        function SetDiscountText(discount)
        {
            if(discount > 0)
            {
                var subtotalText = $('.js-subtotal').find('.pricing-item__total').text().split('$')[1];
                var subTotal = parseFloat(subtotalText.replace(",", ""))

                var discountValue = subTotal * parseFloat(discount) / 100;

                $('.js-discount .pricing-item__title').text('Descuento:' + discount + '%');
                $('.js-discount .pricing-item__total').text(formatCurrency(discountValue));
            }
            else
            {
                $('.js-discount .pricing-item__total').text(formatCurrency(discount));
                $('.js-discount').toggleClass("hide", true);
            }
        }

        function ifDecidir(){
            return $('.js-payment-method-selected').data('decidir');
        }

        $('.js-end-order').click(function (event) {
            $('.js-end-order').attr('disabled', true);
            event.preventDefault();
            var valid = false;

            ValidateDecidir();

            if (valid) {
                $("#DecidirForm").submit();
            }

        });

    </script>

}